﻿// SizeInUnits.jsx

// Скрипт показывает значение числа в различных единицах измерения.
// Подробная информация на кнопке [ ? ] и в папке Info

// Script shows entered number in various units.
// All information is on button [ ? ] and in Info folder
//
// Mikhail Ivanyushin  |  dotextok@gmail.com  |  https://shop.dotextok.ru/en/  |  https://dotextok.ru/

var version = "(13.10.2021)";

////////////////////////////////////////////////////

// English
var mes01 = "Size in various units";
var mes02 = "pixels";
var mes03 = "points";
var mes04 = "mm";
var mes05 = "cm";
var mes06 = "inches";
var mes07 = "picas";
var mes08 = "ciceros";
var mes09 = "Show";
var mes10 = "SizeInVariousUnitsEng.pdf";
var mes11 = "The PDF file with the description of this program was not found. It is named '";
var mes12 = "' and it should be in the 'Info' folder of this script.";

/*
// Русский язык
//var mes01 = "Если единица измерения —";
var mes01 = "Размер в разных единицах";
var mes02 = "пиксели";
var mes03 = "пункты";
var mes04 = "миллиметры";
var mes05 = "сантиметры";
var mes06 = "дюймы";
var mes07 = "пики";
//var mes07 = "пайки";
var mes08 = "цицеро";
var mes09 = "Показать";
var mes10 = "SizeInVariousUnitsRus.pdf";
var mes11 = "Не найден PDF-файл с описанием этой программы. Он называется '";
var mes12 = "' и должен быть в папке 'Info' этого скрипта.";
*/

#targetengine "SizeInUnits"

var programTitul = mes01; // "Size in various units"
var curUnit = "";
var picaAmer = "0p0";
var picaEuro = "0.0";
var ciceroAmer = "0c0";
var ciceroEuro = "0.0";
var round = 4;

var w = new Window( 'palette', programTitul, undefined, {closeButton: true});
w.alignChildren =  ["fill", "fill"]; 
var qweSize = [0,0,14,28];
var showSize = [0,0,180,28];
var pixelGroup = w.add("group");
pixelGroup.orientation = "row";
var pixelUnit = pixelGroup.add("radiobutton");
var pixelSize = pixelGroup.add("edittext {justify: 'center'}");
pixelSize.text = "—";
pixelSize.characters = 8; 
pixelGroup.add("statictext", undefined, mes02); // "pixels"
var pixelQwe= pixelGroup.add("statictext", qweSize, " ");
///
var pointGroup = w.add("group");
pointGroup.orientation = "row";
var pointUnit = pointGroup.add("radiobutton");
var pointSize = pointGroup.add("edittext {justify: 'center'}");
pointSize.text = "—";
pointSize.characters = 8; 
pointGroup.add("statictext", undefined, mes03); // "points"
var pointQwe= pointGroup.add("statictext", qweSize, " ");
///
var mmGroup = w.add("group");
mmGroup.orientation = "row";
var mmUnit = mmGroup.add("radiobutton");
var mmSize = mmGroup.add("edittext {justify: 'center'}");
mmSize.text = "—";
mmSize.characters = 8; 
mmGroup.add("statictext", undefined, mes04); // "mm"
var mmQwe= mmGroup.add("statictext", qweSize, " ");
///
var cmGroup = w.add("group");
cmGroup.orientation = "row";
var cmUnit = cmGroup.add("radiobutton");
var cmSize = cmGroup.add("edittext {justify: 'center'}");
cmSize.text = "—";
cmSize.characters = 8; 
cmGroup.add("statictext", undefined, mes05); // "cm"
var cmQwe= cmGroup.add("statictext", qweSize, " ");
///
var inchGroup = w.add("group");
inchGroup.orientation = "row";
var inchUnit = inchGroup.add("radiobutton");
var inchSize = inchGroup.add("edittext {justify: 'center'}");
inchSize.text = "—";
inchSize.characters = 8; 
inchGroup.add("statictext", undefined, mes06); // "inches"
var inchQwe= inchGroup.add("statictext", qweSize, " ");
///
var groupPicaCiceroCheckbox = w.add("group");
groupPicaCiceroCheckbox.orientation = "row";
var pcGroup = groupPicaCiceroCheckbox.add("group");
pcGroup.orientation = "column";
pcGroup.alignChildren =  ["fill", "fill"];
var picaGroup = pcGroup.add("group");
picaGroup.orientation = "row";
var picaUnit = picaGroup.add("radiobutton");
var picaSize = picaGroup.add("edittext {justify: 'center'}");
picaSize.text = "—";
picaSize.characters = 8; 
picaGroup.add("statictext", undefined, mes07); // "picas"
var picaQwe= picaGroup.add("statictext", qweSize, " ");
///
var ciceroGroup = pcGroup.add("group");
ciceroGroup.orientation = "row";
var ciceroUnit = ciceroGroup.add("radiobutton");
var ciceroSize = ciceroGroup.add("edittext {justify: 'center'}");
ciceroSize.text = "—";
ciceroSize.characters = 8; 
ciceroGroup.add("statictext", undefined, mes08); // "ciceros"
var ciceroQwe= ciceroGroup.add("statictext", qweSize, " ");

var chboxGroup = groupPicaCiceroCheckbox.add("group");
chboxGroup.orientation = "column";
chboxGroup.alignChildren =  ["left", "center"];
var pcCheckbox = chboxGroup.add("checkbox");
pcCheckbox.enabled = false;
///
separator_a = w.add ("panel");
separator_a.minimumSize.height = separator_a.maximumSize.height = 1; 
///
var buttons = w.add("group");
buttons.orientation = "row";
buttons.alignChildren =  ["center", "center"];
var getSize = buttons.add("button", showSize, mes09); // "Show"
getSize.enabled = false;
var info = buttons.add("button", [0,0,28,28], "?");
///
info.onClick = function() { // info.onClick    
var pdfName = mes10;
app.pdfExportPreferences.properties.viewPDF = true;   
var myScriptFile = getScriptPath();
var myScriptFolder = decodeURI(myScriptFile.path);  
var infoFile = File(decodeURI(myScriptFolder + "/Info/" + pdfName)); 
if (!infoFile.exists) { 
    alert(mes11 + pdfName + mes12,programTitul); 
    return; 
    }
else {
        infoFile.execute();
    }
} // info.onClick 
///
pcCheckbox.onClick = function() { // pcCheckbox.onClick 
if (!pcCheckbox.value) {
    picaSize.text = picaAmer; 
    ciceroSize.text = ciceroAmer;
    }
else {
    picaSize.text = picaEuro;
    ciceroSize.text = ciceroEuro;
    }
} // pcCheckbox.onClick 
///

getSize.onClick = function() { // getSize.onClick  
var sizeValue;    
var qweField;
pixelQwe.text = " ";
pointQwe.text = " ";
mmQwe.text = " ";
cmQwe.text = " ";
inchQwe.text = " ";
picaQwe.text = " ";
ciceroQwe.text = " ";

if (pixelUnit.value) { sizeValue = pixelSize; qweField = pixelQwe; }
else if (pointUnit.value) { sizeValue = pointSize; qweField = pointQwe; }
else if (mmUnit.value) { sizeValue = mmSize; qweField = mmQwe; }
else if (cmUnit.value) { sizeValue = cmSize; qweField = cmQwe; }
else if (inchUnit.value) { sizeValue = inchSize; qweField = inchQwe; }
else if (picaUnit.value) { sizeValue = picaSize; qweField = picaQwe; }
else { sizeValue = ciceroSize; qweField = ciceroQwe; }

var inputString = sizeValue.text;  
var pcRez = [];
var inRez = [];
var inchValue = 0;
while (pcRez.length > 0) pcRez.shift();
while (inRez.length > 0) inRez.shift();
regExp = new RegExp(/,/g); // ищем все запятые в строке
inputString = inputString.replace(regExp, "\.");  
if (!picaUnit.value && !ciceroUnit.value && !inchUnit.value) { // ! pc & !cicero
    inRez = inputString.split(" ");
    for (i = 0; i < inRez.length; i++) { // i++
        if (inRez[i].length == 0) continue;    
        if (isNaN(inRez[i]) == true) { qweField.text = "?"; clearFields(); return; }
        inputString = inRez[i];
        break;
        } // i++
    } //  // ! pc & !cicero
else if (inchUnit.value) { // inchUnit.value
    inRez = inputString.split(" ");
    for (i = 0; i < inRez.length; i++) { // i++
        if (inRez[i].length == 0) continue;
        pcRez = inRez[i].split("/");
        if (pcRez.length > 2) { qweField.text = "?"; clearFields(); return; } 
        if (pcRez.length == 1) { // == 1
            if (isNaN(pcRez[0]) == true) { qweField.text = "?"; clearFields(); return; }
            inchValue = Number(inchValue) + Number(pcRez[0]);
            continue;
            } // == 1
        else { // == 2
            if (isNaN(pcRez[0]) == true) { qweField.text = "?"; clearFields(); return; }        
            if (isNaN(pcRez[1]) == true) { qweField.text = "?"; clearFields(); return; } 
            inchValue = Number(inchValue) + Number(pcRez[0]) / Number(pcRez[1]);          
            }  // == 2  
        } // i++
        inputString = inchValue;
    } // inchUnit.value
else { // pc || cicero
    if (picaUnit.value) pcRez = inputString.split("p");
    else pcRez = inputString.split("c");
    if (pcRez.length > 2){ qweField.text = "?"; clearFields(); return; }
    if (pcRez.length == 1) { // == 1
        pcRez[0] = pcRez[0].replace(regExp, "\.");
        if (isNaN(pcRez[0]) == true) { qweField.text = "?"; clearFields(); return; }
        inputString = pcRez[0];
        } // == 1
    else { // == 2
        pcRez[0] = pcRez[0].replace(regExp, "\.");
        if (isNaN(pcRez[0]) == true) { qweField.text = "?"; clearFields(); return; }        
         pcRez[1] = pcRez[1].replace(regExp, "\.");
        if (isNaN(pcRez[1]) == true) { qweField.text = "?"; clearFields(); return; } 
        inputString = Number(pcRez[0]) + Number(pcRez[1]/12);
        }  // == 2
    } // pc || cicero
if (inputString <= 0) { qweField.text = "?"; clearFields(); return; }
pixelSize.text = (UnitValue(inputString, curUnit).as("px")).toFixed(round);
pointSize.text = (UnitValue(inputString, curUnit).as("pt")).toFixed(round);
mmSize.text = (UnitValue(inputString, curUnit).as("mm")).toFixed(round);
cmSize.text = (UnitValue(inputString, curUnit).as("cm")).toFixed(round);
inchSize.text = (UnitValue(inputString, curUnit).as("in")).toFixed(round);
picaEuro = (UnitValue(inputString, curUnit).as("pc")).toFixed(round);
var sizeAsAbobePoints = UnitValue(inputString, curUnit).as("pt");
var floatRez = parseFloat(sizeAsAbobePoints/12);
var entier = parseInt(sizeAsAbobePoints/12);
var diff = floatRez - entier;
var fraction = (diff*12).toFixed(round);
picaAmer = entier + "p" + fraction;
pcCheckbox.enabled = true;
if (!pcCheckbox.value) picaSize.text = picaAmer; else picaSize.text = picaEuro;

//var sizeAsFrenchPoints = sizeAsAbobePoints*3528/3759; // recalculate width in abobe point (0.3528 mm) to width in french point (0.3759 mm)
var sizeAsFrenchPoints = sizeAsAbobePoints*12/(UnitValue("1ci").as("pt")); // it is the idea of Marc Autret how to recalculate a size to french points. Instead using ratio 3528/3759. Rezult is 0.93843843843844

ciceroEuro = UnitValue(inputString, curUnit).as("ci").toFixed(round);
floatRez = parseFloat(sizeAsFrenchPoints/12);
entier = parseInt(sizeAsFrenchPoints/12);
diff = floatRez - entier;
fraction = (diff*12).toFixed(round);
ciceroAmer = entier + "c" + fraction;
if (!pcCheckbox.value) ciceroSize.text = ciceroAmer; else ciceroSize.text = ciceroEuro;
return;
} // getSize.onClick
///
pixelUnit.onClick = function () {
pixelUnit.value = true;    
pointUnit.value = false;
mmUnit.value = false;
cmUnit.value = false;
inchUnit.value = false;
picaUnit.value = false;
ciceroUnit.value = false;
curUnit = "px";
getSize.enabled = true;
}
///
pointUnit.onClick = function () {
pixelUnit.value = false;    
pointUnit.value = true;
mmUnit.value = false;
cmUnit.value = false;
inchUnit.value = false;
picaUnit.value = false;
ciceroUnit.value = false;
curUnit = "pt";
getSize.enabled = true;
}
///
mmUnit.onClick = function () {
pixelUnit.value = false;    
pointUnit.value = false;
mmUnit.value = true;
cmUnit.value = false;
inchUnit.value = false;
picaUnit.value = false;
ciceroUnit.value = false;
curUnit = "mm";
getSize.enabled = true;
}
///
cmUnit.onClick = function () {
pixelUnit.value = false;    
pointUnit.value = false;
mmUnit.value = false;
cmUnit.value = true;
inchUnit.value = false;
picaUnit.value = false;
ciceroUnit.value = false;
curUnit = "cm";
getSize.enabled = true;
}
///
inchUnit.onClick = function () {
pixelUnit.value = false;    
pointUnit.value = false;
mmUnit.value = false;
cmUnit.value = false;
inchUnit.value = true;
picaUnit.value = false;
ciceroUnit.value = false;
curUnit = "in";
getSize.enabled = true;
}
///
picaUnit.onClick = function () {
pixelUnit.value = false;    
pointUnit.value = false;
mmUnit.value = false;
cmUnit.value = false;
inchUnit.value = false;
picaUnit.value = true;
ciceroUnit.value = false;
curUnit = "pc";
getSize.enabled = true;
}
///
ciceroUnit.onClick = function () {
pixelUnit.value = false;    
pointUnit.value = false;
mmUnit.value = false;
cmUnit.value = false;
inchUnit.value = false;
picaUnit.value = false;
ciceroUnit.value = true;
curUnit = "ci";
getSize.enabled = true;
}
///
function clearFields() { // clearFields
if (!pixelUnit.value) pixelSize.text = ""; // "—"
if (!pointUnit.value) pointSize.text = "";
if (!mmUnit.value) mmSize.text = "";
if (!cmUnit.value) cmSize.text = "";
if (!inchUnit.value) inchSize.text = "";
if (!picaUnit.value) picaSize.text = "";
if (!ciceroUnit.value) ciceroSize.text = "";
} // clearFields
///
function getScriptPath() { // getScriptPath
try {
    return app.activeScript;
    }
catch (myError) {
    return File(myError.fileName);
    }
} // getScriptPath()
////////////////
w.show();
//////////////
    
    
   
